﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote68_TabControl_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // 월 매출
        private int[] m_iSales = new int[31];
        // SmartMonthCalendar에 마커를 표시하기 위한 변수
        private SmartX.SmartMonthCalendar.MARKERDAYINFOS m_sMarkInfo = new SmartX.SmartMonthCalendar.MARKERDAYINFOS();

        // Manager
        private string[] m_strManager = { "홍길동", "김가나", "이다라", "박마바" };
        // Building
        private string[] m_strBuilding = { "가나동", "다라동", "마바동" };
        // DeliveryTime
        private string[] m_strDeliveryTime = { "20분", "30분", "40분", "50분", "60분" };

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;

            // 자식Form 설정
            smartForm1.AddChildForm(smartInnerForm1);
            smartForm1.AddChildForm(smartInnerForm2);
            smartForm1.AddChildForm(smartInnerForm3);
            smartForm1.AddChildForm(smartInnerForm4);
            smartForm1.ChildFormLocation(377, 65);
            smartForm1.Show(1);

            // SmartComboBox에 Item 추가
            cbManager.DataSource = m_strManager;
            cbBuilding.DataSource = m_strBuilding;
            cbDeliveryTime.DataSource = m_strDeliveryTime;

            // SmartListBox Column 설정
            SmartX.SmartListBox.COLUMNSTYLE[] sMainFormColumn = new SmartX.SmartListBox.COLUMNSTYLE[4];
            SmartX.SmartListBox.COLUMNSTYLE[] sChildFormColumn = new SmartX.SmartListBox.COLUMNSTYLE[4];

            for (int i = 0; i < sMainFormColumn.Length; i++)
            {
                sMainFormColumn[i].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
                sMainFormColumn[i].iOffsetColumn = 0;
            }

            sMainFormColumn[0].iColumnWidth = 50;
            sMainFormColumn[1].iColumnWidth = 82;
            sMainFormColumn[2].iColumnWidth = 72;
            sMainFormColumn[3].iColumnWidth = 106;

            for (int i = 0; i < sChildFormColumn.Length; i++)
            {
                sChildFormColumn[i].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
                sChildFormColumn[i].iOffsetColumn = 0;
            }

            sChildFormColumn[0].iColumnWidth = 84;
            sChildFormColumn[1].iColumnWidth = 140;
            sChildFormColumn[2].iColumnWidth = 76;
            sChildFormColumn[3].iColumnWidth = 80;

            lstMainFormList.ColumnStyles = sMainFormColumn;
            lstChildFormList.ColumnStyles = sChildFormColumn;

            // 판매가격 초기설정
            for (int i = 0; i < 20; i++)
            {
                m_iSales[i] = 200000;
            }

            int iSale = 0;
            foreach (int iMoney in m_iSales)
            {
                iSale += iMoney;
            }
            labMonthlySales.Text = iSale.ToString();

            // 시간 표시
            labDateTime.Text = smartConfigs1.ControlPanel.GetSystemDateTime().ToString("yyyy-MM-dd, hh:mm:ss");
            // 시간 표시를 위한 타이머 Start
            smartTimer1.Start();

            // 버튼 눌림 표시
            btnMenu.ButtonDown();
            btnFood.ButtonDown();
            // 초기 메뉴는 식사류
            btnFood_Click(sender, e);
        }

        private void ButtonInnerForm_Click(object sender, EventArgs e)
        {
            smartForm1.ChildFormLocation(377, 65);
            if (sender == btnMenu)
            {
                smartForm1.Show(1);
            }
            else if (sender == btnDelivery)
            {
                smartForm1.Show(2);
            }
            else if (sender == btnOrder)
            {
                smartForm1.Show(3);
            }
            else
            {
                smartForm1.Show(4);
            }
        }

        private void smartTimer1_Tick(object sender, EventArgs e)
        {
            labDateTime.Text = smartConfigs1.ControlPanel.GetSystemDateTime().ToString("yyyy-MM-dd, hh:mm:ss");
        }

        // 주문취소 버튼 클릭 시 발생하는 이벤트
        private void btnOrderCancel_Click(object sender, EventArgs e)
        {
            lstMainFormList.ClearAll();
            btnCash.ButtonUp();
            btnCard.ButtonUp();
            labTotalPrice.Text = "";
        }

        // 개별취소 버튼 클릭 시 발생하는 이벤트
        private void btnCancel_Click(object sender, EventArgs e)
        {
            // 선택한 아이템이 있을 경우에만 동작
            if (lstMainFormList.SelectItemIndex == -1)
            {
                return;
            }
            else
            {
                // 선택한 항목을 split하기 위한 배열
                string[] arrMenu1 = new string[4];
                // 항목을 split하여 배열에 저장
                arrMenu1 = lstMainFormList.Items[lstMainFormList.SelectItemIndex].Split('\n');
                // 수량을 저장
                int iCount = Convert.ToInt32(arrMenu1[2]);
                // 메뉴 하나의 가격을 저장
                int iPrice = (Convert.ToInt32(arrMenu1[3]) / iCount);

                // 개수가 1개라면 항목을 제거
                if (iCount == 1)
                {
                    lstMainFormList.RemoveItem(lstMainFormList.SelectItemIndex);
                    // 항목이 제거됬으므로 no를 수정
                    for (int i = 0; i < lstMainFormList.ItemCount; i++)
                    {
                        arrMenu1 = lstMainFormList.Items[i].Split('\n');   //항목을 split하여 배열에 저장
                        lstMainFormList.ModifyItem(i, 0, (i + 1).ToString());
                        lstMainFormList.ModifyItem(i, 1, arrMenu1[1]);
                        lstMainFormList.ModifyItem(i, 2, arrMenu1[2]);
                        lstMainFormList.ModifyItem(i, 3, arrMenu1[3]);
                    }
                }
                else
                {
                    // 1개 이상이라면 개수를 1개 줄인다.
                    lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 0, (lstMainFormList.SelectItemIndex + 1).ToString());
                    lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 1, arrMenu1[1]);
                    lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 2, (iCount - 1).ToString());
                    lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 3, ((iCount - 1) * iPrice).ToString());
                }
            }
        }

        // 리스트가 업데이트될 때 발생하는 이벤트
        private void lstMainFormList_OnUpdateEvent(object sender, EventArgs e)
        {
            // 각 항목을 split하여 저장할 string배열
            string[] arrMenu2 = new string[4];
            // 전체 가격
            int iTotalPrice = 0;

            // 리스트 항목의 개수가 1개 이상일때
            if (lstMainFormList.ItemCount != 0)
            {
                // 항목 개수만큼 반복
                for (int i = 0; i < lstMainFormList.ItemCount; i++)
                {
                    // \n을 기준으로 split
                    arrMenu2 = lstMainFormList.Items[i].Split('\n');
                    // 전체 가격에 합한다
                    iTotalPrice += Convert.ToInt32(arrMenu2[3]);
                }
            }
            
            labTotalPrice.Text = iTotalPrice.ToString();
        }

        // 식사류 클릭 시
        private void btnFood_Click(object sender, EventArgs e)
        {
            smartButton1.ButtonText = "김밥 3000";
            smartButton2.ButtonText = "라면 3000";
            smartButton3.ButtonText = "돈까스 6000";
            smartButton4.ButtonText = "닭발 9000";
            smartButton5.ButtonText = "";
            smartButton6.ButtonText = "";
            smartButton7.ButtonText = "";
            smartButton8.ButtonText = "";
            smartButton9.ButtonText = "";
            smartButton10.ButtonText = "";
        }

        // 음료 클릭 시
        private void btnDrink_Click(object sender, EventArgs e)
        {
            smartButton1.ButtonText = "콜라 1500";
            smartButton2.ButtonText = "사이다 1500";
            smartButton3.ButtonText = "";
            smartButton4.ButtonText = "";
            smartButton5.ButtonText = "";
            smartButton6.ButtonText = "";
            smartButton7.ButtonText = "";
            smartButton8.ButtonText = "";
            smartButton9.ButtonText = "";
            smartButton10.ButtonText = "";
        }

        // 기타 클릭 시
        private void btnEtc_Click(object sender, EventArgs e)
        {
            smartButton1.ButtonText = "소스 500";
            smartButton2.ButtonText = "";
            smartButton3.ButtonText = "";
            smartButton4.ButtonText = "";
            smartButton5.ButtonText = "";
            smartButton6.ButtonText = "";
            smartButton7.ButtonText = "";
            smartButton8.ButtonText = "";
            smartButton9.ButtonText = "";
            smartButton10.ButtonText = "";
        }

        // 메뉴 클릭 시 메뉴가 추가되는 이벤트
        private void ButtonAddMenu_Click(object sender, EventArgs e)
        {
            // 버튼에 내용이 없다면 실행 취소
            if (((SmartX.SmartButton)sender).ButtonText == "")
            {
                return;
            }

            // lstMainFormList의 항목을 Split하여 저장할 배열
            string[] strMenuSplit = new string[4];
            // 클릭한 SmartButton의 Text를 Split하여 저장할 배열
            string[] strButtonSplit = new string[2];
            // lstMainFormList 항목 개수를 저장
            int iListCount = lstMainFormList.ItemCount;
            // 초기 수량 0
            int iMenuCount = 0;
            // 초기 금액 0
            int iMenuPrice = 0;
            // lstMainFormList에서 메뉴를 찾을 시 체크할 플래그
            bool bFind = false;
            // ListBox에 Column으로 데이터를 저장할 배열
            string[] strListData = new string[4];

            // 클릭한 SmartButton의 Text를 Split
            strButtonSplit = ((SmartX.SmartButton)sender).ButtonText.Split(' ');

            // lstMainFormList의 항목 개수가 0개일 때
            if (iListCount == 0)
            {
                // 수량 1개
                iMenuCount = 1;
                // 버튼에 적힌 금액과 수량을 곱한다.
                iMenuPrice = (iMenuCount * Convert.ToInt32(strButtonSplit[1]));
                // lstMainFormList에 항목을 추가
                strListData[0] = "1";
                strListData[1] = strButtonSplit[0];
                strListData[2] = iMenuCount.ToString();
                strListData[3] = iMenuPrice.ToString();
                lstMainFormList.AddItem(strListData);
            }
            else
            {
                // lstMainFormList의 항목개수가 1개 이상일때
                for (int i = 0; i < iListCount; i++)
                {
                    // 배열에 리스트아이템을 split하여 저장(no, 판매내역, 수량, 금액)
                    strMenuSplit = lstMainFormList.Items[i].ToString().Split('\n');

                    // 버튼의 메뉴와 리스트의 메뉴가 일치할 때
                    if (strMenuSplit[1] == strButtonSplit[0])
                    {
                        // 플래그를 true로 설정
                        bFind = true;
                        // 수량을 변수에 저장
                        iMenuCount = Convert.ToInt32(strMenuSplit[2]) + 1;
                        // 가격을 버튼배열의 2번째 값과 수량을 곱하여 계산
                        iMenuPrice = (iMenuCount * Convert.ToInt32(strButtonSplit[1]));

                        // 리스트박스 아이템을 수정
                        lstMainFormList.ModifyItem(i, 0, (i + 1).ToString());
                        lstMainFormList.ModifyItem(i, 1, strButtonSplit[0]);
                        lstMainFormList.ModifyItem(i, 2, iMenuCount.ToString());
                        lstMainFormList.ModifyItem(i, 3, iMenuPrice.ToString());
                        // 메뉴를 수정했으므로 반복문을 빠져나온다.
                        break;
                    }
                }
                // 리스트에서 메뉴를 찾지 못한 경우
                if (bFind == false)
                {
                    // 아이템을 새로 추가한다.
                    iMenuCount = 1;
                    iMenuPrice = (iMenuCount * Convert.ToInt32(strButtonSplit[1]));

                    strListData[0] = (iListCount + 1).ToString();
                    strListData[1] = strButtonSplit[0];
                    strListData[2] = iMenuCount.ToString();
                    strListData[3] = iMenuPrice.ToString();
                    lstMainFormList.AddItem(strListData);
                }
            }
        }

        // lstChildFormList의 Scroll Up/Down 컨트롤을 위한 이벤트
        private void ButtonListControl_Click(object sender, EventArgs e)
        {
            if (sender == btnListUp)
            {
                lstChildFormList.ScrollUp();
            }
            else
            {
                lstChildFormList.ScrollDown();
            }
        }

        private void btnPrint_Click(object sender, EventArgs e)
        {
            if (lstMainFormList.ItemCount != 0)
            {
                string[] strOrderList = new string[4];
                string[] strListData = new string[4];
                strOrderList[0] = cbManager.Text;
                strOrderList[1] = labDateTime.Text;

                if (btnDeliveryOrder.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
                {
                    strOrderList[2] = "배달";
                }
                else
                {
                    strOrderList[2] = "내점";
                }
                strOrderList[3] = labTotalPrice.Text;

                for (int i = 0; i < strListData.Length; i++)
                {
                    strListData[i] = strOrderList[i];
                }

                lstChildFormList.AddItem(strListData);
                lstMainFormList.ClearAll();
                btnDeliveryOrder.ButtonUp();
            }
        }

        // 주문취소 버튼을 클릭하여 ListBox의 아이템 삭제
        private void btnOrderCancel2_Click(object sender, EventArgs e)
        {
            if (lstChildFormList.SelectItemIndex != -1)
            {
                lstChildFormList.RemoveItem(lstChildFormList.SelectItemIndex);
            }
        }

        // 매출 설정
        private void btnClose_Click(object sender, EventArgs e)
        {
            if (labDailySales.Text != "")
            {
                int iDay = Convert.ToInt32(smartMonthCalendar1.Today.Day) - 1;
                m_iSales[iDay] = Convert.ToInt32(labDailySales.Text);
                int iSale = 0;
                foreach (int iMoney in m_iSales)
                {
                    iSale += iMoney;
                }
                labMonthlySales.Text = iSale.ToString();
            }
        }

        // lstChildFormList가 업데이트될 때 매출 저장
        private void lstChildFormList_OnUpdateEvent(object sender, EventArgs e)
        {
            string[] strListSplit = new string[4];
            int iSales = 0;
            for (int i = 0; i < lstChildFormList.ItemCount; i++)
            {
                strListSplit = lstChildFormList.Items[i].ToString().Split('\n');
                iSales += Convert.ToInt32(strListSplit[3]);
            }
            labDailySales.Text = iSales.ToString();
        }

        // SmartMonthCalendar에 마커표시
        private void btnOpen_Click(object sender, EventArgs e)
        {
            smartMonthCalendar1.MarkerInfoAdd(m_sMarkInfo);
            smartMonthCalendar1.MarkerInfosUpdate();
        }

        // 달이 바뀌면 마커 초기화
        private void smartMonthCalendar1_OnMonthChange(int iYear, int iMonth)
        {
            smartMonthCalendar1.MarkerInfoRemoveAll();
        }

        // 날짜 선택시 마커에 정보 저장
        private void smartMonthCalendar1_OnSelectedDayChange(int iYear, int iMonth, int iDay, int iDayMarkerIndex)
        {
            m_sMarkInfo.iYear = iYear;
            m_sMarkInfo.iMonth = iMonth;
            m_sMarkInfo.iDay = iDay;
            m_sMarkInfo.iImageIndex = 0;
        }
    }
}