﻿Public Class Form1

    ' 월 매출
    Private m_iSales As Integer() = New Integer(30) {}
    ' SmartMonthCalendar에 마커를 표시하기 위한 변수
    Private m_sMarkInfo As SmartX.SmartMonthCalendar.MARKERDAYINFOS = New SmartX.SmartMonthCalendar.MARKERDAYINFOS()

    ' Manager
    Private m_strManager As String() = {"홍길동", "김가나", "이다라", "박마바"}
    ' Building
    Private m_strBuilding As String() = {"가나동", "다라동", "마바동"}
    ' DeliveryTime
    Private m_strDeliveryTime As String() = {"20분", "30분", "40분", "50분", "60분"}

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' 자식Form 설정
        SmartForm1.AddChildForm(SmartInnerForm1)
        SmartForm1.AddChildForm(SmartInnerForm2)
        SmartForm1.AddChildForm(SmartInnerForm3)
        SmartForm1.AddChildForm(SmartInnerForm4)
        SmartForm1.ChildFormLocation(377, 65)
        SmartForm1.Show(1)

        ' SmartComboBox에 Item 추가
        cbManager.DataSource = m_strManager
        cbBuilding.DataSource = m_strBuilding
        cbDeliveryTime.DataSource = m_strDeliveryTime

        ' SmartListBox Column 설정
        Dim sMainFormColumn As SmartX.SmartListBox.COLUMNSTYLE() = New SmartX.SmartListBox.COLUMNSTYLE(3) {}
        Dim sChildFormColumn As SmartX.SmartListBox.COLUMNSTYLE() = New SmartX.SmartListBox.COLUMNSTYLE(3) {}

        For i As Integer = 0 To sMainFormColumn.Length - 1
            sMainFormColumn(i).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
            sMainFormColumn(i).iOffsetColumn = 0
        Next

        sMainFormColumn(0).iColumnWidth = 50
        sMainFormColumn(1).iColumnWidth = 82
        sMainFormColumn(2).iColumnWidth = 72
        sMainFormColumn(3).iColumnWidth = 106

        For i As Integer = 0 To sChildFormColumn.Length - 1
            sChildFormColumn(i).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
            sChildFormColumn(i).iOffsetColumn = 0
        Next

        sChildFormColumn(0).iColumnWidth = 84
        sChildFormColumn(1).iColumnWidth = 140
        sChildFormColumn(2).iColumnWidth = 76
        sChildFormColumn(3).iColumnWidth = 80
        lstMainFormList.ColumnStyles = sMainFormColumn
        lstChildFormList.ColumnStyles = sChildFormColumn

        ' 판매가격 초기설정
        For i As Integer = 0 To 20 - 1
            m_iSales(i) = 200000
        Next

        Dim iSale As Integer = 0

        For Each iMoney As Integer In m_iSales
            iSale += iMoney
        Next

        labMonthlySales.Text = iSale.ToString()

        ' 시간 표시
        labDateTime.Text = SmartConfigs1.ControlPanel.GetSystemDateTime().ToString("yyyy-MM-dd, hh:mm:ss")
        ' 시간 표시를 위한 타이머 Start
        SmartTimer1.Start()

        ' 버튼 눌림 표시
        btnMenu.ButtonDown()
        btnFood.ButtonDown()
        ' 초기 메뉴는 식사류
        btnFood_Click(sender, e)
    End Sub

    Private Sub ButtonInnerForm_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOrder.Click, btnMenu.Click, btnManager.Click, btnDelivery.Click
        SmartForm1.ChildFormLocation(377, 65)

        If sender Is btnMenu Then
            SmartForm1.Show(1)
        ElseIf sender Is btnDelivery Then
            SmartForm1.Show(2)
        ElseIf sender Is btnOrder Then
            SmartForm1.Show(3)
        Else
            SmartForm1.Show(4)
        End If
    End Sub

    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        labDateTime.Text = SmartConfigs1.ControlPanel.GetSystemDateTime().ToString("yyyy-MM-dd, hh:mm:ss")
    End Sub

    ' 주문취소 버튼 클릭 시 발생하는 이벤트
    Private Sub btnOrderCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOrderCancel.Click
        lstMainFormList.ClearAll()
        btnCash.ButtonUp()
        btnCard.ButtonUp()
        labTotalPrice.Text = ""
    End Sub

    ' 개별취소 버튼 클릭 시 발생하는 이벤트
    Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCancel.Click
        ' 선택한 아이템이 있을 경우에만 동작
        If lstMainFormList.SelectItemIndex = -1 Then
            Return
        Else
            ' 선택한 항목을 split하기 위한 배열
            Dim arrMenu1 As String() = New String(3) {}
            ' 항목을 split하여 배열에 저장
            arrMenu1 = lstMainFormList.Items(lstMainFormList.SelectItemIndex).Split(vbLf)
            ' 수량을 저장
            Dim iCount As Integer = Convert.ToInt32(arrMenu1(2))
            ' 메뉴 하나의 가격을 저장
            Dim iPrice As Integer = (Convert.ToInt32(arrMenu1(3)) / iCount)

            ' 개수가 1개라면 항목을 제거
            If iCount = 1 Then
                lstMainFormList.RemoveItem(lstMainFormList.SelectItemIndex)
                ' 항목이 제거됬으므로 no를 수정
                For i As Integer = 0 To lstMainFormList.ItemCount - 1
                    arrMenu1 = lstMainFormList.Items(i).Split(vbLf)
                    lstMainFormList.ModifyItem(i, 0, (i + 1).ToString())
                    lstMainFormList.ModifyItem(i, 1, arrMenu1(1))
                    lstMainFormList.ModifyItem(i, 2, arrMenu1(2))
                    lstMainFormList.ModifyItem(i, 3, arrMenu1(3))
                Next
            Else
                ' 1개 이상이라면 개수를 1개 줄인다.
                lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 0, (lstMainFormList.SelectItemIndex + 1).ToString())
                lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 1, arrMenu1(1))
                lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 2, (iCount - 1).ToString())
                lstMainFormList.ModifyItem(lstMainFormList.SelectItemIndex, 3, ((iCount - 1) * iPrice).ToString())
            End If
        End If
    End Sub

    ' 리스트가 업데이트될 때 발생하는 이벤트
    Private Sub lstMainFormList_OnUpdateEvent(ByVal sender As Object, ByVal e As EventArgs) Handles lstMainFormList.OnUpdateEvent
        ' 각 항목을 split하여 저장할 string배열
        Dim arrMenu2 As String() = New String(3) {}
        ' 전체 가격
        Dim iTotalPrice As Integer = 0

        ' 리스트 항목의 개수가 1개 이상일때
        If lstMainFormList.ItemCount <> 0 Then
            ' 항목 개수만큼 반복
            For i As Integer = 0 To lstMainFormList.ItemCount - 1
                ' vbLf를 기준으로 split
                arrMenu2 = lstMainFormList.Items(i).Split(vbLf)
                ' 전체 가격에 합한다
                iTotalPrice += Convert.ToInt32(arrMenu2(3))
            Next
        End If

        labTotalPrice.Text = iTotalPrice.ToString()
    End Sub

    ' 식사류 클릭 시
    Private Sub btnFood_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFood.Click
        smartButton1.ButtonText = "김밥 3000"
        smartButton2.ButtonText = "라면 3000"
        smartButton3.ButtonText = "돈까스 6000"
        smartButton4.ButtonText = "닭발 9000"
        smartButton5.ButtonText = ""
        smartButton6.ButtonText = ""
        smartButton7.ButtonText = ""
        smartButton8.ButtonText = ""
        smartButton9.ButtonText = ""
        smartButton10.ButtonText = ""
    End Sub

    ' 음료 클릭 시
    Private Sub btnDrink_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnDrink.Click
        smartButton1.ButtonText = "콜라 1500"
        smartButton2.ButtonText = "사이다 1500"
        smartButton3.ButtonText = ""
        smartButton4.ButtonText = ""
        smartButton5.ButtonText = ""
        smartButton6.ButtonText = ""
        smartButton7.ButtonText = ""
        smartButton8.ButtonText = ""
        smartButton9.ButtonText = ""
        smartButton10.ButtonText = ""
    End Sub

    ' 기타 클릭 시
    Private Sub btnEtc_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnEtc.Click
        smartButton1.ButtonText = "소스 500"
        smartButton2.ButtonText = ""
        smartButton3.ButtonText = ""
        smartButton4.ButtonText = ""
        smartButton5.ButtonText = ""
        smartButton6.ButtonText = ""
        smartButton7.ButtonText = ""
        smartButton8.ButtonText = ""
        smartButton9.ButtonText = ""
        smartButton10.ButtonText = ""
    End Sub

    ' 메뉴 클릭 시 메뉴가 추가되는 이벤트
    Private Sub ButtonAddMenu_Click(ByVal sender As Object, ByVal e As EventArgs) Handles smartButton9.Click, smartButton8.Click, smartButton7.Click, smartButton6.Click, smartButton5.Click, smartButton4.Click, smartButton3.Click, smartButton2.Click, smartButton10.Click, smartButton1.Click
        ' 버튼에 내용이 없다면 실행 취소
        If (CType(sender, SmartX.SmartButton)).ButtonText = "" Then
            Return
        End If

        ' lstMainFormList의 항목을 Split하여 저장할 배열
        Dim strMenuSplit As String() = New String(3) {}
        ' 클릭한 SmartButton의 Text를 Split하여 저장할 배열
        Dim strButtonSplit As String() = New String(1) {}
        ' lstMainFormList 항목 개수를 저장
        Dim iListCount As Integer = lstMainFormList.ItemCount
        ' 초기 수량 0
        Dim iMenuCount As Integer = 0
        ' 초기 금액 0
        Dim iMenuPrice As Integer = 0
        ' lstMainFormList에서 메뉴를 찾을 시 체크할 플래그
        Dim bFind As Boolean = False
        ' ListBox에 Column으로 데이터를 저장할 배열
        Dim strListData As String() = New String(3) {}
        ' 클릭한 SmartButton의 Text를 Split
        strButtonSplit = (CType(sender, SmartX.SmartButton)).ButtonText.Split(" "c)

        ' lstMainFormList의 항목 개수가 0개일 때
        If iListCount = 0 Then
            ' 수량 1개
            iMenuCount = 1
            ' 버튼에 적힌 금액과 수량을 곱한다.
            iMenuPrice = (iMenuCount * Convert.ToInt32(strButtonSplit(1)))
            ' lstMainFormList에 항목을 추가
            strListData(0) = "1"
            strListData(1) = strButtonSplit(0)
            strListData(2) = iMenuCount.ToString()
            strListData(3) = iMenuPrice.ToString()
            lstMainFormList.AddItem(strListData)
        Else
            ' lstMainFormList의 항목개수가 1개 이상일때
            For i As Integer = 0 To iListCount - 1
                ' 배열에 리스트아이템을 split하여 저장(no, 판매내역, 수량, 금액)
                strMenuSplit = lstMainFormList.Items(i).ToString().Split(vbLf)

                ' 버튼의 메뉴와 리스트의 메뉴가 일치할 때
                If strMenuSplit(1) = strButtonSplit(0) Then
                    ' 플래그를 true로 설정
                    bFind = True
                    ' 수량을 변수에 저장
                    iMenuCount = Convert.ToInt32(strMenuSplit(2)) + 1
                    ' 가격을 버튼배열의 2번째 값과 수량을 곱하여 계산
                    iMenuPrice = (iMenuCount * Convert.ToInt32(strButtonSplit(1)))

                    ' 리스트박스 아이템을 수정
                    lstMainFormList.ModifyItem(i, 0, (i + 1).ToString())
                    lstMainFormList.ModifyItem(i, 1, strButtonSplit(0))
                    lstMainFormList.ModifyItem(i, 2, iMenuCount.ToString())
                    lstMainFormList.ModifyItem(i, 3, iMenuPrice.ToString())
                    ' 메뉴를 수정했으므로 반복문을 빠져나온다.
                    Exit For
                End If
            Next

            ' 리스트에서 메뉴를 찾지 못한 경우
            If bFind = False Then
                ' 아이템을 새로 추가한다.
                iMenuCount = 1
                iMenuPrice = (iMenuCount * Convert.ToInt32(strButtonSplit(1)))

                strListData(0) = (iListCount + 1).ToString()
                strListData(1) = strButtonSplit(0)
                strListData(2) = iMenuCount.ToString()
                strListData(3) = iMenuPrice.ToString()
                lstMainFormList.AddItem(strListData)
            End If
        End If
    End Sub

    ' lstChildFormList의 Scroll Up/Down 컨트롤을 위한 이벤트
    Private Sub ButtonListControl_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnListUp.Click, btnListDown.Click
        If sender Is btnListUp Then
            lstChildFormList.ScrollUp()
        Else
            lstChildFormList.ScrollDown()
        End If
    End Sub

    Private Sub btnPrint_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPrint.Click
        If lstMainFormList.ItemCount <> 0 Then
            Dim strOrderList As String() = New String(3) {}
            Dim strListData As String() = New String(3) {}
            strOrderList(0) = cbManager.Text
            strOrderList(1) = labDateTime.Text

            If btnDeliveryOrder.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then
                strOrderList(2) = "배달"
            Else
                strOrderList(2) = "내점"
            End If

            strOrderList(3) = labTotalPrice.Text

            For i As Integer = 0 To strListData.Length - 1
                strListData(i) = strOrderList(i)
            Next

            lstChildFormList.AddItem(strListData)
            lstMainFormList.ClearAll()
            btnDeliveryOrder.ButtonUp()
        End If
    End Sub

    ' 주문취소 버튼을 클릭하여 ListBox의 아이템 삭제
    Private Sub btnOrderCancel2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOrderCancel2.Click
        If lstChildFormList.SelectItemIndex <> -1 Then
            lstChildFormList.RemoveItem(lstChildFormList.SelectItemIndex)
        End If
    End Sub

    ' 매출 설정
    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        If labDailySales.Text <> "" Then
            Dim iDay As Integer = Convert.ToInt32(smartMonthCalendar1.Today.Day) - 1
            m_iSales(iDay) = Convert.ToInt32(labDailySales.Text)
            Dim iSale As Integer = 0

            For Each iMoney As Integer In m_iSales
                iSale += iMoney
            Next

            labMonthlySales.Text = iSale.ToString()
        End If
    End Sub

    ' lstChildFormList가 업데이트될 때 매출 저장
    Private Sub lstChildFormList_OnUpdateEvent(ByVal sender As Object, ByVal e As EventArgs) Handles lstChildFormList.OnUpdateEvent
        Dim strListSplit As String() = New String(3) {}
        Dim iSales As Integer = 0

        For i As Integer = 0 To lstChildFormList.ItemCount - 1
            strListSplit = lstChildFormList.Items(i).ToString().Split(vbLf)
            iSales += Convert.ToInt32(strListSplit(3))
        Next

        labDailySales.Text = iSales.ToString()
    End Sub

    ' SmartMonthCalendar에 마커표시
    Private Sub btnOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOpen.Click
        smartMonthCalendar1.MarkerInfoAdd(m_sMarkInfo)
        smartMonthCalendar1.MarkerInfosUpdate()
    End Sub

    ' 달이 바뀌면 마커 초기화
    Private Sub smartMonthCalendar1_OnMonthChange(ByVal iYear As Integer, ByVal iMonth As Integer)
        smartMonthCalendar1.MarkerInfoRemoveAll()
    End Sub

    ' 날짜 선택시 마커에 정보 저장
    Private Sub smartMonthCalendar1_OnSelectedDayChange(ByVal iYear As Integer, ByVal iMonth As Integer, ByVal iDay As Integer, ByVal iDayMarkerIndex As Integer)
        m_sMarkInfo.iYear = iYear
        m_sMarkInfo.iMonth = iMonth
        m_sMarkInfo.iDay = iDay
        m_sMarkInfo.iImageIndex = 0
    End Sub
End Class
